<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEcoMonitorReportItem_V3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfEcoMonitorReportItem_V3 extends AbstractStructArrayBase
{
    /**
     * The EcoMonitorReportItem_V3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EcoMonitorReportItem_V3[]
     */
    public $EcoMonitorReportItem_V3;
    /**
     * Constructor method for ArrayOfEcoMonitorReportItem_V3
     * @uses ArrayOfEcoMonitorReportItem_V3::setEcoMonitorReportItem_V3()
     * @param \StructType\EcoMonitorReportItem_V3[] $ecoMonitorReportItem_V3
     */
    public function __construct(array $ecoMonitorReportItem_V3 = array())
    {
        $this
            ->setEcoMonitorReportItem_V3($ecoMonitorReportItem_V3);
    }
    /**
     * Get EcoMonitorReportItem_V3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EcoMonitorReportItem_V3[]|null
     */
    public function getEcoMonitorReportItem_V3()
    {
        return isset($this->EcoMonitorReportItem_V3) ? $this->EcoMonitorReportItem_V3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEcoMonitorReportItem_V3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEcoMonitorReportItem_V3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEcoMonitorReportItem_V3ForArrayConstraintsFromSetEcoMonitorReportItem_V3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEcoMonitorReportItem_V3EcoMonitorReportItem_V3Item) {
            // validation for constraint: itemType
            if (!$arrayOfEcoMonitorReportItem_V3EcoMonitorReportItem_V3Item instanceof \StructType\EcoMonitorReportItem_V3) {
                $invalidValues[] = is_object($arrayOfEcoMonitorReportItem_V3EcoMonitorReportItem_V3Item) ? get_class($arrayOfEcoMonitorReportItem_V3EcoMonitorReportItem_V3Item) : sprintf('%s(%s)', gettype($arrayOfEcoMonitorReportItem_V3EcoMonitorReportItem_V3Item), var_export($arrayOfEcoMonitorReportItem_V3EcoMonitorReportItem_V3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EcoMonitorReportItem_V3 property can only contain items of type \StructType\EcoMonitorReportItem_V3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EcoMonitorReportItem_V3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EcoMonitorReportItem_V3[] $ecoMonitorReportItem_V3
     * @return \ArrayType\ArrayOfEcoMonitorReportItem_V3
     */
    public function setEcoMonitorReportItem_V3(array $ecoMonitorReportItem_V3 = array())
    {
        // validation for constraint: array
        if ('' !== ($ecoMonitorReportItem_V3ArrayErrorMessage = self::validateEcoMonitorReportItem_V3ForArrayConstraintsFromSetEcoMonitorReportItem_V3($ecoMonitorReportItem_V3))) {
            throw new \InvalidArgumentException($ecoMonitorReportItem_V3ArrayErrorMessage, __LINE__);
        }
        if (is_null($ecoMonitorReportItem_V3) || (is_array($ecoMonitorReportItem_V3) && empty($ecoMonitorReportItem_V3))) {
            unset($this->EcoMonitorReportItem_V3);
        } else {
            $this->EcoMonitorReportItem_V3 = $ecoMonitorReportItem_V3;
        }
        return $this;
    }
    /**
     * Add item to EcoMonitorReportItem_V3 value
     * @throws \InvalidArgumentException
     * @param \StructType\EcoMonitorReportItem_V3 $item
     * @return \ArrayType\ArrayOfEcoMonitorReportItem_V3
     */
    public function addToEcoMonitorReportItem_V3(\StructType\EcoMonitorReportItem_V3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EcoMonitorReportItem_V3) {
            throw new \InvalidArgumentException(sprintf('The EcoMonitorReportItem_V3 property can only contain items of type \StructType\EcoMonitorReportItem_V3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EcoMonitorReportItem_V3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EcoMonitorReportItem_V3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EcoMonitorReportItem_V3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EcoMonitorReportItem_V3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EcoMonitorReportItem_V3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EcoMonitorReportItem_V3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EcoMonitorReportItem_V3
     */
    public function getAttributeName()
    {
        return 'EcoMonitorReportItem_V3';
    }
}
